#============================================================================================================
#
#	tH[ǗW[(SAMWISE)
#	samwise.pl
#	---------------------------------------------
#	2002.12.13 start
#	2003.02.10 IsInput,IsInputAllǉ
#------------------------------------------------------------------------------------------------------------
#
#	Object																			; IuWFNg擾
#	DecodeForm																		; tH[fR[h
#	GetArray																		; zfR[h
#	Get																				; 擾
#	Set																				; nbVݒEǉ
#	IsInput																			; w͍ڃ`FbN
#	IsInputAll																		; S͍ڃ`FbN
#
#============================================================================================================
package		SAMWISE;

#------------------------------------------------------------------------------------------------------------
#
#	W[RXgN^ - new
#	-------------------------------------------
#	@FȂ
#	߂lFW[IuWFNg
#
#------------------------------------------------------------------------------------------------------------
sub new
{
	my		$this = shift;
	my		(%FORM,@SRC,$form,$obj);
	
	undef(%FORM);
	undef(@SRC);
	
	if($ENV{'REQUEST_METHOD'} eq "POST"){											# POST\bh
		read(STDIN,$form,$ENV{'CONTENT_LENGTH'});
	}else{																			# GET\bh
		$form = $ENV{'QUERY_STRING'};
	}
	@SRC = split(/&/,$form);														# f[^
	
	$obj = {
		'FORM'	=> \%FORM,
		'SRC'	=> \@SRC
	};
	
	bless $obj,$this;
	
	return $obj;
}

#------------------------------------------------------------------------------------------------------------
#
#	W[fXgN^ - DESTROY
#	-------------------------------------------
#	@FȂ
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub DESTROY
{
}

#------------------------------------------------------------------------------------------------------------
#
#	IuWFNg擾 - Object
#	-------------------------------------------
#	@FȂ
#	߂lFIuWFNg̎Q
#
#------------------------------------------------------------------------------------------------------------
sub Object
{
	my		$this = shift;
	
	return $this->{'FORM'};
}

sub Out
{
	my		$this = shift;
	
	open(DBG,">dbg.txt");
	foreach	(keys %{$this->{'FORM'}}){
		print DBG "$_=" . $this->{'FORM'}->{$_} . "\n";
	}
	close(DBG);
}

#------------------------------------------------------------------------------------------------------------
#
#	tH[fR[h - DecodeForm
#	-------------------------------------------
#	@F$mode : 
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub DecodeForm
{
	my		$this = shift;
	my		($mode) = @_;
	my		($var,$val,$code);
	
	require('./module/jcode.pl');													# jcode.plv
	
	undef(%{$this->{'FORM'}});
	
	foreach	(@{$this->{'SRC'}}){													# ef[^Ƃɏ
		($var,$val) = split(/=/,$_);												# name/valueŕ
		$val	=~ tr/+/ /;
		$val	=~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
		$code	= jcode'getcode(*val);												# R[h擾
		jcode'convert(*val,$code);													# R[h𓝈'
		if	($mode){																# }[h
#			$val	=~ s/&/&amp;/g;													# ꕶ΍ &
			$val	=~ s/"/&quot;/g;
			$val	=~ s/</&lt;/g;													# ꕶ΍ <
			$val	=~ s/>/&gt;/g;													# ꕶ΍ >
#			$val	=~ s/&amp;rlo;/&rlo;/g;											# &rlo;͋܂
#			$val	=~ s/&amp;#/&#/g;												# L
			$val	=~ s/\r\n|\r|\n/<br>/g;											# s
			$val	=~ s/ +<br>/<br>/g;												# +<br>
			$val	=~ s/(@)+<br>/<br>/g;											# +<br>
			$val	=~ s/\0/ʂ/g;												# k
		}
		$this->{'FORM'}->{$var} = $val;												# f[^Zbg
	}
}

#------------------------------------------------------------------------------------------------------------
#
#	tH[fR[h - GetAtArray
#	-------------------------------------------
#	@F$key : 擾L[
#			$f   : ϊtO
#	߂lFL[f[^̔z
#
#------------------------------------------------------------------------------------------------------------
sub GetAtArray
{
	my		$this = shift;
	my		($key,$f) = @_;
	my		($var,$val,$code,@ret);
	
	require('./module/jcode.pl');													# jcode.plv
	
	undef @ret;
	
	foreach	(@{$this->{'SRC'}}){													# ef[^Ƃɏ
		($var,$val) = split(/=/,$_);												# name/valueŕ
		$val	=~ tr/+/ /;
		$val	=~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
		$code	= jcode'getcode(*val);												# R[h擾
		jcode'convert(*val,$code);													# R[h𓝈'
		if	($key eq $var){															# wL[
			if	($f){
#				$val	=~ s/&/&amp;/g;												# ꕶ΍ &
				$val	=~ s/"/&quot;/g;
				$val	=~ s/</&lt;/g;												# ꕶ΍ <
				$val	=~ s/>/&gt;/g;												# ꕶ΍ >
				$val	=~ s/\r\n|\r|\n/<br>/g;										# s
				$val	=~ s/\0//g;													# k
			}
			push(@ret,$val);
		}
	}
	return @ret;
}

#------------------------------------------------------------------------------------------------------------
#
#	tH[擾 - Get
#	-------------------------------------------
#	@F$key : 擾L[
#	߂lFf[^
#
#------------------------------------------------------------------------------------------------------------
sub Get
{
	my		$this = shift;
	my		($key) = @_;
	
	return $this->{'FORM'}->{$key};
}

#------------------------------------------------------------------------------------------------------------
#
#	tH[ݒ - Set
#	-------------------------------------------
#	@F$key  : 擾L[
#			$data : ݒf[^
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub Set
{
	my		$this = shift;
	my		($key,$data) = @_;
	
	$this->{'FORM'}->{$key} = $data;
}

#------------------------------------------------------------------------------------------------------------
#
#	̓`FbN - IsInput
#	-------------------------------------------
#	@F@keylist : 荀ڃXg
#	߂lFOKȂ1,͂Ȃ0
#
#------------------------------------------------------------------------------------------------------------
sub IsInput
{
	my		$this = shift;
	my		(@keylist) = @_;
	
	foreach	(@keylist){
		if	($this->{'FORM'}->{$_} eq ""){
			return 0;
		}
	}
	return 1;
}

#------------------------------------------------------------------------------------------------------------
#
#	S̓`FbN - IsInput
#	-------------------------------------------
#	@FȂ
#	߂lFOKȂ1,͂Ȃ0
#
#------------------------------------------------------------------------------------------------------------
sub IsInputAll
{
	my		$this = shift;
	
	foreach	(keys %{$this->{'FORM'}}){
		if	($this->{'FORM'}->{$_} eq ""){
			return 0;
		}
	}
	return 1;
}

#============================================================================================================
#	W[I[
#============================================================================================================
1;
