#============================================================================================================
#
#	NG[hǗW[(WORMTONGUE)
#	wormtongue.pl
#	---------------------------------------
#	2003.02.06 start
#	2003.04.05 Get,Methodǉ
#------------------------------------------------------------------------------------------------------------
#
#	Object																			; IuWFNg擾
#	Load																			; NG[hǂݍ
#	Save																			; NG[h
#	Set																				; NG[hǉ
#	Get																				; NG[hf[^擾
#	Clear																			; NG[h폜
#	Check																			; NG[h
#	Method																			; NG[h
#
#============================================================================================================
package	WORMTONGUE;

#------------------------------------------------------------------------------------------------------------
#
#	W[RXgN^ - new
#	-------------------------------------------
#	@FȂ
#	߂lFW[IuWFNg
#
#------------------------------------------------------------------------------------------------------------
sub new
{
	my		$this = shift;
	my		(@NGWORD,$METHOD,$SUBSTITUTE,$obj);
	
	undef @NGWORD;
	
	$obj = {
		'METHOD'	=> $METHOD,
		'SUBSTITUTE'=> $SUBSTITUTE,
		'NGWORD'	=> \@NGWORD
	};
	
	bless $obj,$this;
	
	return $obj;
}

#------------------------------------------------------------------------------------------------------------
#
#	W[fXgN^ - DESTROY
#	-------------------------------------------
#	@FȂ
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub DESTROY
{
}

#------------------------------------------------------------------------------------------------------------
#
#	IuWFNg擾 - Object
#	-------------------------------------------
#	@FȂ
#	߂lFIuWFNg̎Q
#
#------------------------------------------------------------------------------------------------------------
sub Object
{
	my		$this = shift;
	
	return $this->{'NGWORD'};
}

#------------------------------------------------------------------------------------------------------------
#
#	NG[hǂݍ - Load
#	-------------------------------------------
#	@F$M : MELKOR
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub Load
{
	my		$this = shift;
	my		($M) = @_;
	my		(@work,$path,$key,$dat,$num);
	
	$path = "." . $M->Get('INFO') . "/ngwords.cgi";
	undef @{$this->{'NGWORD'}};
	
	$num = 1;
	
	if	(-e "$path"){																# t@C݂
		open(NGWORD,"<$path");														# t@CI[v
		@work = <NGWORD>;
		close(NGWORD);
		foreach	(@work){
			chomp($_);
			if	($num == 1){
				($key,$dat) = split(/<>/,$_);
				$this->{'METHOD'} = $dat;
			}
			elsif	($num == 2){
				($key,$dat) = split(/<>/,$_);
				$this->{'SUBSTITUTE'} = $dat;
			}
			else{
				push(@{$this->{'NGWORD'}},$_)
			}
			$num ++;
		}
	}
}

#------------------------------------------------------------------------------------------------------------
#
#	NG[h - Save
#	-------------------------------------------
#	@F$M : MELKOR
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub Save
{
	my		$this = shift;
	my		($M) = @_;
	my		($path,$method,$subs);
	
	$path	= "." . $M->Get('INFO') . "/ngwords.cgi";
	$method	= $this->{'METHOD'};
	$subs	= $this->{'SUBSTITUTE'};
	
	eval{	chmod(0666,$path);	};													# p[~bVݒ
	open(NGW,">$path");																# t@CI[v
	eval{	flock(NGW,2);	};
	
	print NGW "METHOD<>$method\n";
	print NGW "SUBSTITUTE<>$subs\n";
	foreach	(@{$this->{'NGWORD'}}){
		print NGW "$_\n";
	}
	close(NGW);
	eval{	chmod($M->Get('PM-ADM'),$path);	};										# p[~bVݒ
}

#------------------------------------------------------------------------------------------------------------
#
#	NG[hǉ - Set
#	-------------------------------------------
#	@F$key : NG[h
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub Set
{
	my		$this = shift;
	my		($key) = @_;
	
	push(@{$this->{'NGWORD'}},$key);
}

#------------------------------------------------------------------------------------------------------------
#
#	NG[hf[^擾 - Get
#	-------------------------------------------
#	@F$key : 擾L[
#	߂lFf[^
#
#------------------------------------------------------------------------------------------------------------
sub Get
{
	my		$this = shift;
	my		($key) = @_;
	
	return $this->{$key}
}

#------------------------------------------------------------------------------------------------------------
#
#	NG[hf[^ݒ - SetData
#	-------------------------------------------
#	@F$key  : ݒL[
#			$data : ݒf[^
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub SetData
{
	my		$this = shift;
	my		($key,$data) = @_;
	
	$this->{$key} = $data;
}

#------------------------------------------------------------------------------------------------------------
#
#	NG[hNA - Clear
#	-------------------------------------------
#	@FȂ
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub Clear
{
	my		$this = shift;
	
	undef(@{$this->{'NGWORD'}});
}

#------------------------------------------------------------------------------------------------------------
#
#	NG[h - Check
#	-------------------------------------------
#	@F$S : SAMWISE
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub Check
{
	my		$this = shift;
	my		($S) = @_;
	my		($pNGW,$pFORM,$word,$work);
	
	$pNGW	= $this->{'NGWORD'};
	$pFORM	= $S->Object();
	
	foreach	$word	(@$pNGW){
		foreach	(keys %$pFORM){
			$work = $pFORM->{$_};
			if	($work =~ /$word/){
				if	($this->{'METHOD'} eq 'host'){		return 2;	}				# zXg
				if	($this->{'METHOD'} eq 'disable'){	return 3;	}				# ݕs
				return 1;															# ̑
			}
		}
	}
	return 0;
}

#------------------------------------------------------------------------------------------------------------
#
#	NG[h - Method
#	-------------------------------------------
#	@F$S : SAMWISE
#	߂lFȂ
#
#------------------------------------------------------------------------------------------------------------
sub Method
{
	my		$this = shift;
	my		($S) = @_;
	my		($pForm,$word,$data,$subs);
	
	if	($this->{'METHOD'} ne 'delete' && $this->{'METHOD'} ne 'substitute'){		# ւ폜̂ݏ
		return;
	}
	
	$pForm	= $S->Object();
	$subs	= $this->{'SUBSTITUTE'};
	
	foreach	$word (@{$this->{'NGWORD'}}){											# SNG[h𑖍
		foreach	(keys %$pForm){														# StH[𑖍
			$data = $pForm->{$_};
			if	($data =~ /$word/){													# NG[hv
				if	($this->{'METHOD'} eq 'substitute'){							# ͑֕
					$data =~ s/$word/$subs/g;
				}
				elsif	($this->{'METHOD'} eq 'delete'){							# ͍폜
					$data =~ s/$word//g;
				}
				else{
					return;
				}
				$S->Set($_,$data);													# Đݒ
			}
		}
	}
}

#============================================================================================================
#	W[I[
#============================================================================================================
1;
